## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
##
## JFirstContact Mod by Jeckel. Based on Snaitf's First Contact mod.
##

from CvPythonExtensions import *

import Popup as PyPopup
import CvUtil
import sys

import CvConfigParser
import CvPath

import CvJFirstContactGameUtils

import SdToolKit
sdEcho = SdToolKit.sdEcho

# globals
gc = CyGlobalContext()

fc = CvJFirstContactGameUtils.JFirstContact()


############################################################################


# This option allows you to turn JUnitCapture Mod on or off.
# True - JUnitCapture Mod is on.
# False - JUnitCapture Mod is off.
# Default = True
g_bJFirstContactFeaturesEnabled = True


############################################################################



def loadConfigurationData():
        global g_bJFirstContactFeaturesEnabled

        # Load the JFirstContact Mod Config INI file containing all of the configuration information
	config = CvConfigParser.CvConfigParser("JFirstContact Mod Config.ini")
		
	# If the JFirstContact Mod's config.ini file was found then load its values
	if(config != None):
                g_bJFirstContactFeaturesEnabled = config.getboolean("JFirstContact Mod", "JFirstContact Features Enabled", True)


class CvJFirstContactEventManager:
	def __init__(self, eventManager):
                # initialize base class

                #eventManager.addEventHandler("GameStart", self.onGameStart)
                eventManager.addEventHandler("BeginPlayerTurn", self.onBeginPlayerTurn)
                eventManager.addEventHandler("firstContact", self.onFirstContact)
                #eventManager.addEventHandler("unitMove", self.onUnitMove)


        def onUnitMove(self, argsList):
		'unit move'
		pPlot,pUnit = argsList

                pass


	def onGameStart(self, argsList):
		'Called at the start of the game'

                pass


	def onBeginPlayerTurn(self, argsList):
		'Called at the beginning of a players turn'
		iGameTurn, iPlayer = argsList

		if (g_bJFirstContactFeaturesEnabled) and (gc.getGame().isFinalInitialized()):
                        fc.onBeginPlayerTurn(argsList)


        def onFirstContact(self, argsList):
		'Contact'
		iTeamX, iHasMetTeamY = argsList

		iRealGameTurn = gc.getGame().countNumHumanGameTurnActive()

                loadConfigurationData()

                if (gc.getGame().isFinalInitialized()) and (not gc.getGame().GetWorldBuilderMode()):
                        if (g_bJFirstContactFeaturesEnabled):
                                #strMessage = str(iRealGameTurn) + "This is not the first turn." + str(self.activateJFirstContact)
                                #sdEcho(strMessage)
                                fc.onFirstContact(argsList)
                        #else:
                                #strMessage = str(iRealGameTurn) + "This is the first turn." + str(self.activateJFirstContact)
                                #sdEcho(strMessage)


